package cn.ibizlab.businesscentral.core.odoo_product.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_product.domain.Product_attribute_custom_value;
import cn.ibizlab.businesscentral.core.odoo_product.filter.Product_attribute_custom_valueSearchContext;
import cn.ibizlab.businesscentral.core.odoo_product.service.IProduct_attribute_custom_valueService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.util.helper.EBSServiceImpl;
import cn.ibizlab.businesscentral.core.odoo_product.mapper.Product_attribute_custom_valueMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;

import org.springframework.util.StringUtils;

/**
 * 实体[产品属性自定义值] 服务对象接口实现
 */
@Slf4j
@Service("Product_attribute_custom_valueServiceImpl")
public class Product_attribute_custom_valueServiceImpl extends EBSServiceImpl<Product_attribute_custom_valueMapper, Product_attribute_custom_value> implements IProduct_attribute_custom_valueService {

    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.odoo_product.service.IProduct_attribute_valueService productAttributeValueService;
    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.odoo_base.service.IRes_usersService resUsersService;
    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.odoo_sale.service.ISale_order_lineService saleOrderLineService;

    protected int batchSize = 500;

    public String getIrModel(){
        return "product.attribute.custom.value" ;
    }

    private boolean messageinfo = false ;

    public void setMessageInfo(boolean messageinfo){
        this.messageinfo = messageinfo ;
    }

    @Override
    @Transactional
    public boolean create(Product_attribute_custom_value et) {
        boolean mail_create_nosubscribe = et.get("mail_create_nosubscribe") != null;
        boolean mail_create_nolog = et.get("mail_create_nolog") != null;
        boolean mail_notrack = et.get("mail_notrack") != null;
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getId()),et);

        if (messageinfo && !mail_create_nosubscribe) {
            cn.ibizlab.businesscentral.util.security.SpringContextHolder.getBean(cn.ibizlab.businesscentral.core.extensions.service.Mail_followersExService.class).add_default_followers(this,et);
        }

        if (messageinfo && !mail_create_nolog) {
            cn.ibizlab.businesscentral.util.security.SpringContextHolder.getBean(cn.ibizlab.businesscentral.core.extensions.service.Mail_messageExService.class).add_default_create_message(this,et);
        }

        if (messageinfo && !mail_notrack) {

        }
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<Product_attribute_custom_value> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(Product_attribute_custom_value et) {
        Product_attribute_custom_value old = new Product_attribute_custom_value() ;
        CachedBeanCopier.copy(get(et.getId()), old);
        boolean mail_notrack = et.get("mail_notrack") != null;
        fillParentData(et);
         if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("id",et.getId())))
            return false;
        CachedBeanCopier.copy(get(et.getId()),et);
        if (messageinfo && !mail_notrack) {
            cn.ibizlab.businesscentral.util.security.SpringContextHolder.getBean(cn.ibizlab.businesscentral.core.extensions.service.Mail_tracking_valueExService.class).message_track(this,old,et);
        }
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<Product_attribute_custom_value> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(Long key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<Long> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public Product_attribute_custom_value get(Long key) {
        Product_attribute_custom_value et = getById(key);
        if(et==null){
            et=new Product_attribute_custom_value();
            et.setId(key);
        }
        else{
        }
        return et;
    }

    @Override
    public Product_attribute_custom_value getDraft(Product_attribute_custom_value et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(Product_attribute_custom_value et) {
        return (!ObjectUtils.isEmpty(et.getId()))&&(!Objects.isNull(this.getById(et.getId())));
    }
    @Override
    @Transactional
    public boolean save(Product_attribute_custom_value et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(Product_attribute_custom_value et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<Product_attribute_custom_value> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<Product_attribute_custom_value> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<Product_attribute_custom_value> selectByAttributeValueId(Long id) {
        return baseMapper.selectByAttributeValueId(id);
    }
    @Override
    public void resetByAttributeValueId(Long id) {
        this.update(new UpdateWrapper<Product_attribute_custom_value>().set("attribute_value_id",null).eq("attribute_value_id",id));
    }

    @Override
    public void resetByAttributeValueId(Collection<Long> ids) {
        this.update(new UpdateWrapper<Product_attribute_custom_value>().set("attribute_value_id",null).in("attribute_value_id",ids));
    }

    @Override
    public void removeByAttributeValueId(Long id) {
        this.remove(new QueryWrapper<Product_attribute_custom_value>().eq("attribute_value_id",id));
    }

	@Override
    public List<Product_attribute_custom_value> selectByCreateUid(Long id) {
        return baseMapper.selectByCreateUid(id);
    }
    @Override
    public void removeByCreateUid(Long id) {
        this.remove(new QueryWrapper<Product_attribute_custom_value>().eq("create_uid",id));
    }

	@Override
    public List<Product_attribute_custom_value> selectByWriteUid(Long id) {
        return baseMapper.selectByWriteUid(id);
    }
    @Override
    public void removeByWriteUid(Long id) {
        this.remove(new QueryWrapper<Product_attribute_custom_value>().eq("write_uid",id));
    }

	@Override
    public List<Product_attribute_custom_value> selectBySaleOrderLineId(Long id) {
        return baseMapper.selectBySaleOrderLineId(id);
    }
    @Override
    public void resetBySaleOrderLineId(Long id) {
        this.update(new UpdateWrapper<Product_attribute_custom_value>().set("sale_order_line_id",null).eq("sale_order_line_id",id));
    }

    @Override
    public void resetBySaleOrderLineId(Collection<Long> ids) {
        this.update(new UpdateWrapper<Product_attribute_custom_value>().set("sale_order_line_id",null).in("sale_order_line_id",ids));
    }

    @Override
    public void removeBySaleOrderLineId(Long id) {
        this.remove(new QueryWrapper<Product_attribute_custom_value>().eq("sale_order_line_id",id));
    }


    /**
     * 查询集合 数据集
     */
    @Override
    public Page<Product_attribute_custom_value> searchDefault(Product_attribute_custom_valueSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<Product_attribute_custom_value> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<Product_attribute_custom_value>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(Product_attribute_custom_value et){
        //实体关系[DER1N_PRODUCT_ATTRIBUTE_CUSTOM_VALUE__PRODUCT_ATTRIBUTE_VALUE__ATTRIBUTE_VALUE_ID]
        if(!ObjectUtils.isEmpty(et.getAttributeValueId())){
            cn.ibizlab.businesscentral.core.odoo_product.domain.Product_attribute_value odooAttributeValue=et.getOdooAttributeValue();
            if(ObjectUtils.isEmpty(odooAttributeValue)){
                cn.ibizlab.businesscentral.core.odoo_product.domain.Product_attribute_value majorEntity=productAttributeValueService.get(et.getAttributeValueId());
                et.setOdooAttributeValue(majorEntity);
                odooAttributeValue=majorEntity;
            }
            et.setAttributeValueIdText(odooAttributeValue.getName());
        }
        //实体关系[DER1N_PRODUCT_ATTRIBUTE_CUSTOM_VALUE__RES_USERS__CREATE_UID]
        if(!ObjectUtils.isEmpty(et.getCreateUid())){
            cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users odooCreate=et.getOdooCreate();
            if(ObjectUtils.isEmpty(odooCreate)){
                cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users majorEntity=resUsersService.get(et.getCreateUid());
                et.setOdooCreate(majorEntity);
                odooCreate=majorEntity;
            }
            et.setCreateUidText(odooCreate.getName());
        }
        //实体关系[DER1N_PRODUCT_ATTRIBUTE_CUSTOM_VALUE__RES_USERS__WRITE_UID]
        if(!ObjectUtils.isEmpty(et.getWriteUid())){
            cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users odooWrite=et.getOdooWrite();
            if(ObjectUtils.isEmpty(odooWrite)){
                cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users majorEntity=resUsersService.get(et.getWriteUid());
                et.setOdooWrite(majorEntity);
                odooWrite=majorEntity;
            }
            et.setWriteUidText(odooWrite.getName());
        }
        //实体关系[DER1N_PRODUCT_ATTRIBUTE_CUSTOM_VALUE__SALE_ORDER_LINE__SALE_ORDER_LINE_ID]
        if(!ObjectUtils.isEmpty(et.getSaleOrderLineId())){
            cn.ibizlab.businesscentral.core.odoo_sale.domain.Sale_order_line odooSaleOrderLine=et.getOdooSaleOrderLine();
            if(ObjectUtils.isEmpty(odooSaleOrderLine)){
                cn.ibizlab.businesscentral.core.odoo_sale.domain.Sale_order_line majorEntity=saleOrderLineService.get(et.getSaleOrderLineId());
                et.setOdooSaleOrderLine(majorEntity);
                odooSaleOrderLine=majorEntity;
            }
            et.setSaleOrderLineIdText(odooSaleOrderLine.getName());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<Product_attribute_custom_value> getProductAttributeCustomValueByIds(List<Long> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<Product_attribute_custom_value> getProductAttributeCustomValueByEntities(List<Product_attribute_custom_value> entities) {
        List ids =new ArrayList();
        for(Product_attribute_custom_value entity : entities){
            Serializable id=entity.getId();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }



}



